import { DiscordGuildProfileMigrator } from "../businessObjects/discord/DiscordGuildProfile.js";
import { VersionedObject, VersionedObjectMigrator } from "../businessObjects/VersionedObject.js";
import { ESocialType } from "../enum/ESocialType.js";
import { SocialPrimaryKey } from "../primitives/index.js";
export declare abstract class SocialGroupProfile extends VersionedObject {
    pKey: SocialPrimaryKey;
    type: ESocialType;
    ownerId: SocialPrimaryKey;
    static CURRENT_VERSION: number;
    constructor(pKey: SocialPrimaryKey, type: ESocialType, ownerId: SocialPrimaryKey);
}
export declare class InvalidSocialGroupProfile extends SocialGroupProfile {
    pKey: SocialPrimaryKey;
    type: ESocialType;
    ownerId: SocialPrimaryKey;
    static CURRENT_VERSION: number;
    constructor(pKey: SocialPrimaryKey, type: ESocialType, ownerId: SocialPrimaryKey);
    getVersion(): number;
}
export declare class SocialGroupProfileMigrator extends VersionedObjectMigrator<SocialGroupProfile> {
    getCurrentVersion(): number;
    protected discordMigrator: DiscordGuildProfileMigrator;
    constructor();
    protected factory(data: Record<string, unknown>): SocialGroupProfile;
    protected getUpgradeFunctions(): Map<number, (data: Record<string, unknown>, version: number) => Record<string, unknown>>;
}
//# sourceMappingURL=SocialGroupProfile.d.ts.map