"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SocialGroupProfileMigrator = exports.InvalidSocialGroupProfile = exports.SocialGroupProfile = void 0;
const DiscordGuildProfile_js_1 = require("../businessObjects/discord/DiscordGuildProfile.js");
const VersionedObject_js_1 = require("../businessObjects/VersionedObject.js");
const ESocialType_js_1 = require("../enum/ESocialType.js");
const index_js_1 = require("../primitives/index.js");
class SocialGroupProfile extends VersionedObject_js_1.VersionedObject {
    constructor(pKey, type, ownerId) {
        super();
        this.pKey = pKey;
        this.type = type;
        this.ownerId = ownerId;
    }
}
exports.SocialGroupProfile = SocialGroupProfile;
SocialGroupProfile.CURRENT_VERSION = 1;
class InvalidSocialGroupProfile extends SocialGroupProfile {
    constructor(pKey, type, ownerId) {
        super(pKey, type, ownerId);
        this.pKey = pKey;
        this.type = type;
        this.ownerId = ownerId;
    }
    getVersion() {
        return DiscordGuildProfile_js_1.DiscordGuildProfile.CURRENT_VERSION;
    }
}
exports.InvalidSocialGroupProfile = InvalidSocialGroupProfile;
InvalidSocialGroupProfile.CURRENT_VERSION = 1;
class SocialGroupProfileMigrator extends VersionedObject_js_1.VersionedObjectMigrator {
    constructor() {
        super();
        this.discordMigrator = new DiscordGuildProfile_js_1.DiscordGuildProfileMigrator();
    }
    getCurrentVersion() {
        return DiscordGuildProfile_js_1.DiscordGuildProfile.CURRENT_VERSION;
    }
    factory(data) {
        switch (data["type"]) {
            case ESocialType_js_1.ESocialType.DISCORD:
                return this.discordMigrator.factory(data);
                break;
        }
        return new InvalidSocialGroupProfile(// Cannot return null
        (0, index_js_1.SocialPrimaryKey)(data["pKey"]), ESocialType_js_1.ESocialType[data["type"]], (0, index_js_1.SocialPrimaryKey)(data["ownerId"]));
    }
    getUpgradeFunctions() {
        return new Map();
    }
}
exports.SocialGroupProfileMigrator = SocialGroupProfileMigrator;
//# sourceMappingURL=SocialGroupProfile.js.map