import { DiscordProfileMigrator } from "../businessObjects/discord/DiscordProfile.js";
import { VersionedObject, VersionedObjectMigrator } from "../businessObjects/VersionedObject.js";
import { ESocialType } from "../enum/ESocialType.js";
import { SocialPrimaryKey } from "../primitives/index.js";
export declare abstract class SocialProfile extends VersionedObject {
    pKey: SocialPrimaryKey;
    type: ESocialType;
    static CURRENT_VERSION: number;
    constructor(pKey: SocialPrimaryKey, type: ESocialType);
}
export declare class InvalidSocialProfile extends SocialProfile {
    pKey: SocialPrimaryKey;
    type: ESocialType;
    static CURRENT_VERSION: number;
    constructor(pKey: SocialPrimaryKey, type: ESocialType);
    getVersion(): number;
}
export declare class SocialProfileMigrator extends VersionedObjectMigrator<SocialProfile> {
    getCurrentVersion(): number;
    protected discordMigrator: DiscordProfileMigrator;
    constructor();
    protected factory(data: Record<string, unknown>): SocialProfile;
    protected getUpgradeFunctions(): Map<number, (data: Record<string, unknown>, version: number) => Record<string, unknown>>;
}
//# sourceMappingURL=SocialProfile.d.ts.map