"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SocialProfileMigrator = exports.InvalidSocialProfile = exports.SocialProfile = void 0;
const DiscordProfile_js_1 = require("../businessObjects/discord/DiscordProfile.js");
const VersionedObject_js_1 = require("../businessObjects/VersionedObject.js");
const ESocialType_js_1 = require("../enum/ESocialType.js");
const index_js_1 = require("../primitives/index.js");
class SocialProfile extends VersionedObject_js_1.VersionedObject {
    constructor(pKey, type) {
        super();
        this.pKey = pKey;
        this.type = type;
    }
}
exports.SocialProfile = SocialProfile;
SocialProfile.CURRENT_VERSION = 1;
class InvalidSocialProfile extends SocialProfile {
    constructor(pKey, type) {
        super(pKey, type);
        this.pKey = pKey;
        this.type = type;
    }
    getVersion() {
        return DiscordProfile_js_1.DiscordProfile.CURRENT_VERSION;
    }
}
exports.InvalidSocialProfile = InvalidSocialProfile;
InvalidSocialProfile.CURRENT_VERSION = 1;
class SocialProfileMigrator extends VersionedObject_js_1.VersionedObjectMigrator {
    constructor() {
        super();
        this.discordMigrator = new DiscordProfile_js_1.DiscordProfileMigrator();
    }
    getCurrentVersion() {
        return SocialProfile.CURRENT_VERSION;
    }
    factory(data) {
        switch (data["type"]) {
            case ESocialType_js_1.ESocialType.DISCORD:
                return this.discordMigrator.factory(data);
                break;
        }
        return new InvalidSocialProfile(// Cannot return null
        (0, index_js_1.SocialPrimaryKey)(data["pKey"]), ESocialType_js_1.ESocialType[data["type"]]);
    }
    getUpgradeFunctions() {
        return new Map();
    }
}
exports.SocialProfileMigrator = SocialProfileMigrator;
//# sourceMappingURL=SocialProfile.js.map