import { SocialGroupProfile } from "../../businessObjects/SocialGroupProfile.js";
import { ISO8601DateString, SocialPrimaryKey, UnixTimestamp, URLString, Username } from "../../primitives/index.js";
import { Integer } from "../../primitives/Integer.js";
import { SnowflakeID } from "../../primitives/SnowflakeID.js";
export declare class DiscordGuildProfile extends SocialGroupProfile {
    id: SnowflakeID;
    discordUserProfileId: SnowflakeID;
    name: string;
    isOwner: boolean;
    permissions: Integer;
    icon: URLString | null;
    joinedAt: UnixTimestamp | null;
    static CURRENT_VERSION: number;
    constructor(id: SnowflakeID, discordUserProfileId: SnowflakeID, // this should be translated to ownerId
    name: string, isOwner: boolean, permissions: Integer, icon: URLString | null, joinedAt: UnixTimestamp | null);
    deriveKey(id: SnowflakeID): SocialPrimaryKey;
    getVersion(): number;
}
export interface DiscordGuildProfileAPIResponse {
    id: SnowflakeID;
    name: string;
    icon: URLString;
    owner: boolean;
    permissions: Integer;
}
export interface DiscordGuildMembershipAPIResponse {
    is_pending: boolean;
    joined_at: ISO8601DateString;
    user: {
        id: SnowflakeID;
        username: Username;
    };
}
export declare class DiscordGuildProfileMigrator {
    factory(data: Record<string, unknown>): DiscordGuildProfile;
}
//# sourceMappingURL=DiscordGuildProfile.d.ts.map