"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiscordGuildProfileMigrator = exports.DiscordGuildProfile = void 0;
const SocialGroupProfile_js_1 = require("../../businessObjects/SocialGroupProfile.js");
const index_js_1 = require("../../enum/index.js");
const index_js_2 = require("../../primitives/index.js");
const Integer_js_1 = require("../../primitives/Integer.js");
const SnowflakeID_js_1 = require("../../primitives/SnowflakeID.js");
class DiscordGuildProfile extends SocialGroupProfile_js_1.SocialGroupProfile {
    constructor(id, discordUserProfileId, // this should be translated to ownerId
    name, isOwner, permissions, icon, joinedAt) {
        super((0, index_js_2.SocialPrimaryKey)(`discord-group-${id}`), index_js_1.ESocialType.DISCORD, (0, index_js_2.SocialPrimaryKey)(`discord-${discordUserProfileId}`));
        this.id = id;
        this.discordUserProfileId = discordUserProfileId;
        this.name = name;
        this.isOwner = isOwner;
        this.permissions = permissions;
        this.icon = icon;
        this.joinedAt = joinedAt;
    }
    deriveKey(id) {
        return (0, index_js_2.SocialPrimaryKey)(`discord-group-${id}`);
    }
    getVersion() {
        return DiscordGuildProfile.CURRENT_VERSION;
    }
}
exports.DiscordGuildProfile = DiscordGuildProfile;
DiscordGuildProfile.CURRENT_VERSION = 1;
class DiscordGuildProfileMigrator {
    factory(data) {
        return new DiscordGuildProfile((0, SnowflakeID_js_1.SnowflakeID)(data["id"]), (0, SnowflakeID_js_1.SnowflakeID)(data["discordUserProfileId"]), (0, index_js_2.Username)(data["name"]), data["isOwner"], (0, Integer_js_1.Integer)(data["permissions"]), data["icon"], (0, index_js_2.UnixTimestamp)(data["joinedAt"]));
    }
}
exports.DiscordGuildProfileMigrator = DiscordGuildProfileMigrator;
//# sourceMappingURL=DiscordGuildProfile.js.map