import { OAuth2Tokens } from "../../businessObjects/OAuth2Tokens.js";
import { SocialProfile } from "../../businessObjects/SocialProfile.js";
import { Integer, SnowflakeID, SocialPrimaryKey, Username } from "../../primitives/index.js";
export declare class DiscordProfile extends SocialProfile {
    id: SnowflakeID;
    username: Username;
    displayName: string | null;
    discriminator: string;
    avatar: string | null;
    flags: Integer;
    oauth2Tokens: OAuth2Tokens;
    static CURRENT_VERSION: number;
    constructor(id: SnowflakeID, username: Username, displayName: string | null, discriminator: string, avatar: string | null, flags: Integer, oauth2Tokens: OAuth2Tokens);
    deriveKey(id: SnowflakeID): SocialPrimaryKey;
    getVersion(): number;
}
export declare class DiscordProfileMigrator {
    factory(data: Record<string, unknown>): DiscordProfile;
}
//# sourceMappingURL=DiscordProfile.d.ts.map