"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiscordProfileMigrator = exports.DiscordProfile = void 0;
const SocialProfile_js_1 = require("../../businessObjects/SocialProfile.js");
const index_js_1 = require("../../enum/index.js");
const index_js_2 = require("../../primitives/index.js");
class DiscordProfile extends SocialProfile_js_1.SocialProfile {
    constructor(id, username, displayName, discriminator, avatar, flags, oauth2Tokens) {
        super((0, index_js_2.SocialPrimaryKey)(`discord-${id}`), index_js_1.ESocialType.DISCORD);
        this.id = id;
        this.username = username;
        this.displayName = displayName;
        this.discriminator = discriminator;
        this.avatar = avatar;
        this.flags = flags;
        this.oauth2Tokens = oauth2Tokens;
    }
    deriveKey(id) {
        return (0, index_js_2.SocialPrimaryKey)(`discord-${id}`);
    }
    getVersion() {
        return DiscordProfile.CURRENT_VERSION;
    }
}
exports.DiscordProfile = DiscordProfile;
DiscordProfile.CURRENT_VERSION = 1;
class DiscordProfileMigrator {
    factory(data) {
        return new DiscordProfile((0, index_js_2.SnowflakeID)(data["id"]), (0, index_js_2.Username)(data["username"]), data["displayName"], data["discriminator"], data["avatar"], (0, index_js_2.Integer)(data["flags"]), data["oauth2Tokens"]);
    }
}
exports.DiscordProfileMigrator = DiscordProfileMigrator;
//# sourceMappingURL=DiscordProfile.js.map