import { DiscordConfig } from "../businessObjects";
import { ChainId, ProviderUrl, URLString } from "../primitives";
export interface IConfigOverrides {
    controlChainId?: ChainId;
    supportedChains?: ChainId[];
    ipfsFetchBaseUrl?: URLString;
    defaultInsightPlatformBaseUrl?: URLString;
    accountIndexingPollingIntervalMS?: number;
    accountBalancePollingIntervalMS?: number;
    accountNFTPollingIntervalMS?: number;
    covalentApiKey?: string;
    moralisApiKey?: string;
    nftScanApiKey?: string;
    poapApiKey?: string;
    dnsServerAddress?: URLString;
    dataWalletBackupIntervalMS?: number;
    backupChunkSizeTarget?: number;
    ceramicNodeURL?: URLString;
    controlChainProviderURL?: ProviderUrl;
    requestForDataCheckingFrequency?: number;
    domainFilter?: string;
    defaultGoogleCloudBucket?: string;
    enableBackupEncryption?: boolean;
    discordOverrides?: Partial<DiscordConfig>;
}
//# sourceMappingURL=IConfigOverrides.d.ts.map