import { Observable, Subject } from "rxjs";
import { LinkedAccount, MetatransactionSignatureRequest, PermissionsGrantedEvent, PermissionsRequestedEvent, SDQLQueryRequest } from "../businessObjects/index.js";
import { DataWalletAddress, DomainName, SnowflakeID } from "../primitives/index.js";
export interface ISnickerdoodleCoreEvents {
    onInitialized: Observable<DataWalletAddress>;
    onQueryPosted: Observable<SDQLQueryRequest>;
    onAccountAdded: Observable<LinkedAccount>;
    onAccountRemoved: Observable<LinkedAccount>;
    onMetatransactionSignatureRequested: Observable<MetatransactionSignatureRequest>;
    onPermissionsGranted: Observable<PermissionsGrantedEvent>;
    onPermissionsRequested: Observable<PermissionsRequestedEvent>;
    onPermissionsRevoked: Observable<DomainName>;
    onDiscordProfileLinked: Subject<SnowflakeID>;
    onDiscordProfileUnlinked: Subject<SnowflakeID>;
}
//# sourceMappingURL=ISnickerdoodleCoreEvents.d.ts.map